
// FOR THOSE OF YOU THAT IMPROVE UPON THIS HERE CODE I ASK YOU ONE THING
// PLEASE POST A COPY UP ON THE FOREX FORUMS FOR YOUR FELLOW TRADERS

#property indicator_chart_window

extern int     Window            = 0;
extern int     Corner            = 2;
extern int     UpDown            = 60;
extern int     LeftRight         = 0;
extern color   BackGroundColor   = White;
extern bool    SortedDisplay     = true;
extern string  Symbol_Suffix     = "";

int      X_position      = 0;
int      Y_position      = 0;
color    PanelColor1     = C'144,144,144';
extern color    PanelColor2     = C'20,20,20';
extern color    PanelColor3     = C'180,30,50';

string buffer_name = "XCP";
int Font_size = 12;

#define Majors_Number 8

int chartpair[2];
string buffer;
string Majors[]  = {"USD","EUR","GBP","JPY","CHF","XAU","NZD","AUD"};            

string Symbols[] = {"EURUSD", "GBPUSD", "USDJPY", "USDCHF", "XAUUSD", "AUDUSD", "NZDUSD",
                    "EURGBP", "EURJPY", "EURCHF", "EURAUD", "EURNZD",
                    "GBPJPY", "GBPCHF", "GBPAUD", "GBPNZD",
                    "AUDJPY", "AUDCHF", "AUDNZD",
                    "CHFJPY", "NZDJPY",
                    "USDSGD"};

string space = "";
string NomeIndi;
int Xoffset[4]={135,150,135,150};  
int Yoffset[4]={0,0,0,0};
  
  
int Translate(string symbol)
   {
   for(int i=0;i<Majors_Number;i++)     if(Majors[i] == symbol)   break;  
   return(i);
   }   




int init()
  {
   X_position += LeftRight;
   Y_position += UpDown;
   NomeIndi = WindowExpertName();
   string currency=StringSubstr(Symbol(),0,3);
   chartpair[0]=Translate(currency);
   currency=StringSubstr(Symbol(),3,3);
   chartpair[1]=Translate(currency);
   Show_Panel();
   Y_position+=0;
   
  return(0);
  }




int deinit()
  {
  for (int i = 0; i <= ArraySize(Majors)*2; i++) 
      {    
       ObjectDelete(Majors[i]+"_val");
       ObjectDelete(Majors[i]+"_nom");
       ObjectDelete(Majors[i]+"_pos");
       }    
       ObjectDelete("XAA-Panel-1");
       ObjectDelete("XAA-Panel-2");
       ObjectDelete("XAA-Panel-3");
       ObjectDelete("XAA-Panel-4");
       ObjectDelete("XAA-Panel-5");
       ObjectDelete("XAA-Panel-6");
       ObjectDelete("XAA-Panel-7");
       ObjectDelete("XAA-Panel-8");
       ObjectDelete("XAA-Panel-9");
       DeleteExistingLabels();
  
   return(0);
  }



void  Show_Panel()
{
      string text="g";
      int xoffset=130,fontsize=80;
      CreateXX2_Labels("XAA-Panel-1",X_position+Xoffset[Corner]-xoffset+1,Y_position+37, text, fontsize-2, "Webdings", PanelColor1);
      CreateXX2_Labels("XAA-Panel-2",X_position+Xoffset[Corner]-xoffset+1,Y_position+15, text, fontsize-2, "Webdings", PanelColor1); 
      CreateXX2_Labels("XAA-Panel-3",X_position+Xoffset[Corner]-xoffset+3,Y_position+16, "gggg", 19, "Webdings", PanelColor3);
      CreateXX2_Labels("XAA-Panel-4",X_position+Xoffset[Corner]-xoffset+3,Y_position+22, "gggg", 19, "Webdings", PanelColor3);
      CreateXX2_Labels("XAA-Panel-5",X_position+Xoffset[Corner]-xoffset+3,Y_position+106,"gggg", 19, "Webdings", PanelColor3);
      CreateXX2_Labels("XAA-Panel-6",X_position+Xoffset[Corner]-xoffset+3,Y_position+113,"gggg", 19, "Webdings", PanelColor3); 
      CreateXX2_Labels("XAA-Panel-7",X_position+Xoffset[Corner]-xoffset+3,Y_position+46, "gggg", 19, "Webdings", PanelColor2);
      CreateXX2_Labels("XAA-Panel-8",X_position+Xoffset[Corner]-xoffset+3,Y_position+65, "gggg", 19, "Webdings", PanelColor2);
      CreateXX2_Labels("XAA-Panel-9",X_position+Xoffset[Corner]-xoffset+3,Y_position+82, "gggg", 19, "Webdings", PanelColor2);
      }
      
      
      
      
int start()
  {  
   int    counted_bars=IndicatorCounted();
   displayMeter();

   return(0);
  }
  


void displayMeter() 
   {
   double ValoreZero[Majors_Number,2];
   color  ColoreZero[Majors_Number,2];
   
   for(int currency=0; currency<Majors_Number; currency++)
      {
      ValoreZero[currency,0] = currency_strength(Majors[currency]);
      ValoreZero[currency,1] = currency;
      }

   if(SortedDisplay)
      {
      int mode=MODE_DESCEND;
      if(Corner > 1)   mode=MODE_ASCEND;
      ArraySort(ValoreZero,WHOLE_ARRAY,0,mode);
      }
      
   int win = WindowFind(NomeIndi);
   double value;
   int j,Y2=Y_position+14;
   string Font,Name;
   for(int i=0; i<Majors_Number; i++)
   {
      j = ValoreZero[i,1];
      color Color=C'210,210,210';//SpringGreen;
      Font="Courier New Bold";
      value=ValoreZero[i,0]*10.0;
      buffer=buffer_name + Majors[j];
      switch(Corner)
      
         {
         case 0: Name=(i+1)+" "+Majors[j]; break;
         case 1: Name=(i+1)+" "+Majors[j]; break;
         case 2: Name=(8-i)+" "+Majors[j]; break;
         case 3: Name=(8-i)+" "+Majors[j]; break;
         }
      
      if(j == chartpair[0] || j == chartpair[1]) {Font="Courier New Bold"; Color=White;}
      objectCreate(buffer+"_nom", Corner, X_position+Xoffset[Corner]-124+1, Y2+2, 0, Name, Font_size, Font, Color);
      objectCreate(buffer+"_val", Corner, X_position+Xoffset[Corner]-64+1, Y2+2, 0, DoubleToStr(value,0)+"%", Font_size, Font, Color);
      Y2 += 15;
   }  
}


double currency_strength(string couple) {
   int index;
   string Pair;
   double HiLo;
   double ld_28;
   double ld_ret_36 = 0;
   
    
   int cnt = 0;
   for (int i = 0; i < ArraySize(Symbols); i++) {
      index = 0;
      Pair = Symbols[i]+Symbol_Suffix;
      if (couple == StringSubstr(Pair, 0, 3) || couple == StringSubstr(Pair, 3, 3)) {
         Pair = Pair + space;
         HiLo = (MarketInfo(Pair, MODE_HIGH) - MarketInfo(Pair, MODE_LOW)) * MarketInfo(Pair, MODE_POINT);
         if (HiLo != 0.0) {
            
            ld_28 = 100.0 * ((MarketInfo(Pair, MODE_BID) - MarketInfo(Pair, MODE_LOW)) / HiLo * MarketInfo(Pair, MODE_POINT));
            if (ld_28 >  3.0) index = 1;
            if (ld_28 > 10.0) index = 2;
            if (ld_28 > 25.0) index = 3;
            if (ld_28 > 40.0) index = 4;
            if (ld_28 > 50.0) index = 5;
            if (ld_28 > 60.0) index = 6;
            if (ld_28 > 75.0) index = 7;
            if (ld_28 > 90.0) index = 8;
            if (ld_28 > 97.0) index = 9;
            cnt++;
            if (couple == StringSubstr(Pair, 3, 3)) index = 9 - index;
            ld_ret_36 += index;
         }
      }
   }
   ld_ret_36 /= cnt;
   return (ld_ret_36);  
}



void objectCreate(string nome, int angolo, int val_x, int val_y, int val_ang, string testo = "-", int fontsize = 42, string fontname = "Arial", color color1 = -1)
   {
   if (ObjectFind(nome) != 0)       ObjectCreate(nome, OBJ_LABEL, Window, 0, 0);
   
   ObjectSet(nome, OBJPROP_CORNER, Corner);
   ObjectSet(nome, OBJPROP_COLOR, color1);
   ObjectSet(nome, OBJPROP_BACK, 0);
   ObjectSet(nome, OBJPROP_XDISTANCE, val_x);
   ObjectSet(nome, OBJPROP_YDISTANCE, val_y);
   ObjectSet(nome, OBJPROP_ANGLE, val_ang);
   ObjectSetText(nome, testo, fontsize, fontname, color1);
   }
   
   
   
void CreateXX2_Labels( string bj, int xj, int yj, string text, int fontsize, string font, color colore ) 
   {
   ObjectCreate( bj, OBJ_LABEL, Window, 0, 0 );
   ObjectSet( bj, OBJPROP_CORNER, Corner );
   ObjectSet( bj, OBJPROP_XDISTANCE,xj);
   ObjectSet( bj, OBJPROP_YDISTANCE,yj+(Font_size/fontsize)*UpDown);
   ObjectSet( bj, OBJPROP_BACK, 0 );
   ObjectSetText(bj, text, fontsize, font, colore);
   }



void DeleteExistingLabels() {
   string l_name_4;
   int l_objs_total_0 = ObjectsTotal(OBJ_LABEL);
   if (l_objs_total_0 > 0) {
      for (int l_objs_total_12 = l_objs_total_0; l_objs_total_12 >= 0; l_objs_total_12--) {
         l_name_4 = ObjectName(l_objs_total_12);
         if (StringFind(l_name_4, buffer_name, 0) >= 0) ObjectDelete(l_name_4);
      }
   }
}